//
//  main.swift
//  structs-and-refs
//
//  Created by Fritz Anderson on 8/9/16.
//  Copyright © 2016 Fritz Anderson. All rights reserved.
//

import Foundation

class C {
    var value: Int
    init(value: Int) { self.value = value }
}

struct S { var c: C }

var reusedTheBackingStore = false

func addInts(x: S, y: S) -> S {
    var tmp = x
    // Don't use x after this point so that it gets forwarded into tmp
    if isUniquelyReferencedNonObjC(&tmp.c) {
        reusedTheBackingStore = true
        tmp.c.value += y.c.value
        return tmp
    } else {
        reusedTheBackingStore = false
        return S(c: C(value: tmp.c.value + y.c.value))
    }
}

let s_x = S(c: C(value: 99))
let s_y = S(c: C(value: -98))
let s_result = addInts(x: s_x, y: s_y)

print(reusedTheBackingStore ? "DID" : "Did NOT",
      "reuse the backing store.")
print("The result backing store", s_result.c === s_x.c ? "IS" : "IS NOT", "the same as the target store.")
print()
print("x.c value =", s_x.c.value)
print("y.c value =", s_y.c.value)
print("result.c value =", s_result.c.value)
print()

